# Detect player login

scoreboard players add @s ticks 1
execute unless score @s ticks = #global ticks run function build:player/login/main







# Give effects

effect give @s saturation 1 124 true
effect give @s resistance 1 124 true
execute if score @s[gamemode=!spectator] arena matches 0 at @s unless block ~ -61 ~ air run effect give @s speed 1 4 true
execute if score @s[gamemode=!spectator] arena matches 0 at @s unless block ~ -61 ~ air run effect give @s jump_boost 1 6 true







# Process clicks

execute if score @s click matches 1.. run function build:player/click/main







# Manage triggers

scoreboard players reset @s[scores={arena=1..},tag=!spectator] spectate
scoreboard players enable @s[scores={arena=0}] spectate
scoreboard players enable @s[tag=spectator] spectate
execute if entity @s[gamemode=!spectator,scores={spectate=1  }] run function build:player/spectate/spectator
execute if entity @s[gamemode=!spectator,scores={spectate=11 }] run function build:player/spectate/forest
execute if entity @s[gamemode=!spectator,scores={spectate=12 }] run function build:player/spectate/cave
execute if entity @s[gamemode=!spectator,scores={spectate=13 }] run function build:player/spectate/city
execute if entity @s[gamemode=!spectator,scores={spectate=14 }] run function build:player/spectate/ice
execute if entity @s[gamemode= spectator,scores={spectate=1..},tag=!spectator] run function build:player/spectate/adventure
execute if entity @s[gamemode= spectator,scores={spectate=1..},tag= spectator] run function build:player/spectate/toggle



scoreboard players enable @s lobby
scoreboard players set @s[scores={lobby=1..}] ticks 0
scoreboard players set @s[scores={lobby=1..}] session 0
scoreboard players set @s lobby 0



scoreboard players enable @s info
execute if score @s info matches 1.. run playsound minecraft:ui.button.click master @s

tellraw @s[scores={info=10}] [{"text":"\n Telephone","color":"gold"},{"text":"\n\nYour standard Building Game experience. Players write a topic they want (or use a predefined one) and once everyone is ready, a new player has to build that topic within a time limit. After the time is up, players have to guess what that topic and the game continues through the building and guess phases until a certain point. Once that's up, you're able to view the wackiness of the lines that have gone through.","color":"green"}]
tellraw @s[scores={info=11}] [{"text":"\n Tourney","color":"gold"},{"text":"\n\nEveryone is given one random topic from a pool of themes and has to start building that specific topic. Once time is up, everyone moves to every build and votes from a point system. After 30 seconds or everyone has voted, you keep moving to each build until all builds have been voted once. Person with the lowest points loses, but not to worry! You can still vote on builds for the next phases until the rounds keep going for a winner. There is a standardized score that helps determine who the top 3 placements are.","color":"green"}]
tellraw @s[scores={info=12}] [{"text":"\n Build Battle","color":"gold"},{"text":"\n\nA theme is chosen at random and players are to build that topic. After the building phase is up in time, everyone goes to each build and scores them based on appearance for 30 seconds or until everyone has voted. Once all votes are up, the players with the highest score wins. Uses the same score grading that tourney uses.","color":"green"}]
tellraw @s[scores={info=13}] [{"text":"\n 1v1s","color":"gold"},{"text":"\n\nYou'll be dragged to a 1v1 arena where you and another person will be building a topic. When time is up, you'll go through the voting stage to start voting on different builds to see who did it better. You'll also have people voting on your builds. If you lose, don't worry - you're still going to be facing everyone. The game keeps going until everyone faces everyone.","color":"green"}]

tellraw @s[scores={info=20}] [{"text":"\nModifiers are events which modify the game experience about every 30 seconds.","color":"gold"},{"text":"\n\n Modifiers: Off","color":"white"},{"text":"\n\nNo modifiers on the game.","color":"green"}]
tellraw @s[scores={info=21}] [{"text":"\nModifiers are events which modify the game experience about every 30 seconds.","color":"gold"},{"text":"\n\n Modifiers: Fun","color":"green"},{"text":"\n\nFun modifiers add goofy and harmless modifiers to your game like confetti bombs and Reuben.","color":"green"}]
tellraw @s[scores={info=22}] [{"text":"\nModifiers are events which modify the game experience about every 30 seconds.","color":"gold"},{"text":"\n\n Modifiers: Annoying","color":"yellow"},{"text":"\n\nAnnoying modifiers get in the way of the building process. They can shove you around, scramble your inventory, or swap your gamemode without warning.","color":"green"}]
tellraw @s[scores={info=23}] [{"text":"\nModifiers are events which modify the game experience about every 30 seconds.","color":"gold"},{"text":"\n\n Modifiers: Chaotic","color":"red"},{"text":"\n\nChaotic modifiers will grief your build by swapping out color blocks, covering it with sand, and even refactoring your build. Only the brave should have this setting enabled!","color":"green"}]

scoreboard players set @s info 0



scoreboard players reset @s[scores={arena=0}] floor
scoreboard players reset @s[gamemode=spectator] floor
execute unless score #forest_phase value matches 3 run scoreboard players reset @s[scores={arena=1}] floor
execute unless score #cave_phase value matches 3 run scoreboard players reset @s[scores={arena=2}] floor
execute unless score #city_phase value matches 3 run scoreboard players reset @s[scores={arena=3}] floor
execute unless score #ice_phase value matches 3 run scoreboard players reset @s[scores={arena=4}] floor

execute if score #forest_phase value matches 3 run scoreboard players enable @s[gamemode=!spectator,scores={arena=1}] floor
execute if score #cave_phase value matches 3 run scoreboard players enable @s[gamemode=!spectator,scores={arena=2}] floor
execute if score #city_phase value matches 3 run scoreboard players enable @s[gamemode=!spectator,scores={arena=3}] floor
execute if score #ice_phase value matches 3 run scoreboard players enable @s[gamemode=!spectator,scores={arena=4}] floor

execute if entity @s[tag=floor_action] run function build:player/floor/action
execute if score @s floor matches 1.. run function build:player/floor/main







# Manage plot checker board

scoreboard players set #boolean value 0
execute if score @s plot_checker matches 0 at @s unless block ~ -63 ~ air run scoreboard players set #boolean value 1
execute if score @s plot_checker matches 1 at @s unless block ~ -63 ~ white_concrete run scoreboard players set #boolean value 1
execute if score @s plot_checker matches 2 at @s unless block ~ -63 ~ black_concrete run scoreboard players set #boolean value 1

execute if score #boolean value matches 1 if entity @s[gamemode=!spectator] run function build:player/change_plot

execute at @s if block ~ -63 ~ air run scoreboard players set @s plot_checker 0
execute at @s if block ~ -63 ~ white_concrete run scoreboard players set @s plot_checker 1
execute at @s if block ~ -63 ~ black_concrete run scoreboard players set @s plot_checker 2







# Delete illegal blocks

execute if score @s place_piston matches 1.. at @s run fill ~-8 ~-8 ~-8 ~7 ~7 ~7 air replace piston
execute if score @s place_sticky_piston matches 1.. at @s run fill ~-8 ~-8 ~-8 ~7 ~7 ~7 air replace sticky_piston

execute at @s[gamemode=!spectator] run fill ~-1 ~-1 ~-1 ~1 ~2 ~1 air replace #build:portal

scoreboard players set @s place_piston 0
scoreboard players set @s place_sticky_piston 0

clear @s #build:illegal_items







# Put back in the overworld if they entered into another dimension

execute unless predicate build:player/overworld at @s in overworld run tp @s ~ ~ ~







# Prevent the player from leaving

execute at @s[gamemode=!spectator] if block ~ -61 ~ #build:section_markers positioned ~-1 -10 ~-1 if entity @s[dx=1,dy=5,dz=1] run tellraw @s {"text":"Hey! Don't leave the map!","color":"red"}
execute at @s[gamemode=!spectator] if block ~ -61 ~ #build:section_markers positioned ~-1 021 ~-1 if entity @s[dx=1,dy=9,dz=1] run tellraw @s {"text":"Hey! Don't leave the map!","color":"red"}
execute at @s[gamemode=!spectator] if block ~ -61 ~ #build:section_markers positioned ~-1 -10 ~-1 if entity @s[dx=1,dy=5,dz=1] at @s run tp @s ~ 1 ~
execute at @s[gamemode=!spectator] if block ~ -61 ~ #build:section_markers positioned ~-1 021 ~-1 if entity @s[dx=1,dy=9,dz=1] at @s run tp @s ~ 19 ~







# Process modifiers

execute at @s[scores={modifier_timer=1..}] run function build:player/modifiers/main

execute if entity @s[tag=modifier.frog   ] run function build:player/modifiers/frog
execute if entity @s[tag=modifier.chicken] run function build:player/modifiers/chicken